MPI_Type_create_keyval(3)

NAME
MPI_Type_create_keyval - Create an attribute keyval for MPI datatypes

SYNOPSIS
int MPI_Type_create_keyval(MPI_Type_copy_attr_function *type_copy_attr_fn,
                         MPI_Type_delete_attr_function *type_delete_attr_fn,
                         int *type_keyval, void *extra_state)

INPUT PARAMETERS
type_copy_attr_fn
    - copy callback function for type_keyval (function)
type_delete_attr_fn
    - delete callback function for type_keyval (function)
extra_state
    - extra state for callback functions

OUTPUT PARAMETER
type_keyval
    - key value for future access (integer)

NOTES
Default copy and delete functions are available. These are
MPI_TYPE_NULL_COPY_FN
    - empty copy function
MPI_TYPE_NULL_DELETE_FN
    - empty delete function
MPI_TYPE_DUP_FN
    - simple dup function

RETURN VALUE FROM ATTRIBUTE CALLBACKS
The MPI-2 versions of the attribute callbacks should return either MPI_SUCCESS on success or a valid MPI error code or class on failure. The MPI standard is ambiguous on this point, but as MPI-2 provides the routines MPI_Add_error_class and MPI_Add_error_code that allow the user to define and use MPI error codes and classes.

THREAD AND INTERRUPT SAFETY
This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as malloc or other non-MPICH runtime routines that are themselves not interrupt-safe.

NOTES FOR FORTRAN
All MPI routines in Fortran (except for MPI_WTIME and MPI_WTICK ) have an additional argument ierr at the end of the argument list. ierr is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the call statement. All MPI objects (e.g., MPI_Datatype , MPI_Comm ) are of type INTEGER in Fortran.

ERRORS
All MPI routines (except MPI_Wtime and MPI_Wtick ) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with MPI_Comm_set_errhandler (for communicators), MPI_File_set_errhandler (for files), and MPI_Win_set_errhandler (for RMA windows). The MPI-1 routine MPI_Errhandler_set may be used but its use is deprecated. The predefined error handler MPI_ERRORS_RETURN may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.
MPI_SUCCESS
    - No error; MPI routine completed successfully.
MPI_ERR_OTHER
    - Other error; use MPI_Error_string to get more information about this error code.

LOCATION
type_create_keyval.c